diff --git a/doc/guides/howto/lm_bond_virtio_sriov.rst b/doc/guides/howto/lm_bond_virtio_sriov.rst
index 07563b3e24..02ba1cdf5d 100644
--- a/doc/guides/howto/lm_bond_virtio_sriov.rst
+++ b/doc/guides/howto/lm_bond_virtio_sriov.rst
@@ -591,7 +591,7 @@ Set up DPDK in the Virtual Machine
    rmmod virtio-pci ixgbevf
 
    modprobe uio
-   insmod /root/dpdk/x86_64-default-linux-gcc/kmod/igb_uio.ko
+   insmod /root/dpdk/<build_dir>/kernel/linux/igb_uio/igb_uio.ko
 
    /root/dpdk/usertools/dpdk-devbind.py -b igb_uio 0000:00:03.0
    /root/dpdk/usertools/dpdk-devbind.py -b igb_uio 0000:00:04.0
@@ -613,7 +613,7 @@ Run testpmd in the Virtual Machine.
 
    # use for bonding of virtio and vf tests in VM
 
-   /root/dpdk/x86_64-default-linux-gcc/app/testpmd \
+   /root/dpdk/<build_dir>/app/dpdk-testpmd \
    -l 0-3 -n 4 --socket-mem 350 --  --i --port-topology=chained
 
 .. _lm_bond_virtio_sriov_switch_conf:
diff --git a/doc/guides/howto/lm_virtio_vhost_user.rst b/doc/guides/howto/lm_virtio_vhost_user.rst
index ecb7832906..330ff5a9c8 100644
--- a/doc/guides/howto/lm_virtio_vhost_user.rst
+++ b/doc/guides/howto/lm_virtio_vhost_user.rst
@@ -421,7 +421,7 @@ setup_dpdk_virtio_in_vm.sh
    rmmod virtio-pci
 
    modprobe uio
-   insmod /root/dpdk/x86_64-default-linux-gcc/kmod/igb_uio.ko
+   insmod /root/dpdk/<build_dir>/kernel/linux/igb_uio/igb_uio.ko
 
    /root/dpdk/usertools/dpdk-devbind.py -b igb_uio 0000:00:03.0
    /root/dpdk/usertools/dpdk-devbind.py -b igb_uio 0000:00:04.0
@@ -437,5 +437,5 @@ run_testpmd_in_vm.sh
    # Run testpmd for use with vhost_user sample app.
    # test system has 8 cpus (0-7), use cpus 2-7 for VM
 
-   /root/dpdk/x86_64-default-linux-gcc/app/testpmd \
+   /root/dpdk/<build_dir>/app/dpdk-testpmd \
    -l 0-5 -n 4 --socket-mem 350 -- --burst=64 --i
diff --git a/doc/guides/howto/packet_capture_framework.rst b/doc/guides/howto/packet_capture_framework.rst
index 946a21c8ed..d457989607 100644
--- a/doc/guides/howto/packet_capture_framework.rst
+++ b/doc/guides/howto/packet_capture_framework.rst
@@ -52,11 +52,7 @@ Some things to note:
   initialization code. Refer to the ``app/test-pmd/testpmd.c`` code and look
   for ``pdump`` keyword to see how this is done.
 
-* The ``dpdk-pdump`` tool depends on the libpcap based PMD which is disabled
-  by default in the build configuration files, owing to an external dependency
-  on the libpcap development files. Once the libpcap development files are
-  installed, the libpcap based PMD can be enabled by setting
-  ``CONFIG_RTE_LIBRTE_PMD_PCAP=y`` and recompiling the DPDK.
+* The ``dpdk-pdump`` tool depends on the libpcap based PMD.
 
 
 Test Environment
@@ -73,17 +69,6 @@ for packet capturing on the DPDK port in
    Packet capturing on a DPDK port using the dpdk-pdump tool.
 
 
-Configuration
--------------
-
-Modify the DPDK primary application to initialize the packet capture framework
-as mentioned in the above notes and enable the following config options and
-build DPDK::
-
-     CONFIG_RTE_LIBRTE_PMD_PCAP=y
-     CONFIG_RTE_LIBRTE_PDUMP=y
-
-
 Running the Application
 -----------------------
 
@@ -93,11 +78,11 @@ inspect them using ``tcpdump``.
 
 #. Launch testpmd as the primary application::
 
-     sudo ./app/testpmd -c 0xf0 -n 4 -- -i --port-topology=chained
+     sudo ./<build_dir>/app/dpdk-testpmd -c 0xf0 -n 4 -- -i --port-topology=chained
 
 #. Launch the pdump tool as follows::
 
-     sudo ./build/app/dpdk-pdump -- \
+     sudo ./<build_dir>/app/dpdk-pdump -- \
           --pdump 'port=0,queue=*,rx-dev=/tmp/capture.pcap'
 
 #. Send traffic to dpdk_port0 from traffic generator.
diff --git a/doc/guides/howto/pvp_reference_benchmark.rst b/doc/guides/howto/pvp_reference_benchmark.rst
index 64b1f4d8ec..1d4a4b0232 100644
--- a/doc/guides/howto/pvp_reference_benchmark.rst
+++ b/doc/guides/howto/pvp_reference_benchmark.rst
@@ -99,14 +99,7 @@ Build Qemu:
 DPDK build
 ~~~~~~~~~~
 
-Build DPDK:
-
-   .. code-block:: console
-
-      git clone git://dpdk.org/dpdk
-      cd dpdk
-      export RTE_SDK=$PWD
-      make install T=x86_64-native-linux-gcc DESTDIR=install
+See :doc:`../linux_gsg/build_dpdk` for details.
 
 
 Testpmd launch
@@ -117,7 +110,7 @@ Testpmd launch
    .. code-block:: console
 
       modprobe vfio-pci
-      $RTE_SDK/install/sbin/dpdk-devbind -b vfio-pci 0000:11:00.0 0000:11:00.1
+      ./dpdk/usertools/dpdk-devbind -b vfio-pci 0000:11:00.0 0000:11:00.1
 
    .. Note::
 
@@ -129,7 +122,7 @@ Testpmd launch
 
    .. code-block:: console
 
-      $RTE_SDK/install/bin/testpmd -l 0,2,3,4,5 --socket-mem=1024 -n 4 \
+      ./dpdk/<build_dir>/app/dpdk-testpmd -l 0,2,3,4,5 --socket-mem=1024 -n 4 \
           --vdev 'net_vhost0,iface=/tmp/vhost-user1' \
           --vdev 'net_vhost1,iface=/tmp/vhost-user2' -- \
           --portmask=f -i --rxq=1 --txq=1 \
@@ -309,18 +302,10 @@ Guest tuning
         echo "obase=16;$(( 0x$(cat $i) & ~$clear_mask ))" | bc > $i
       done
 
-
 DPDK build
 ~~~~~~~~~~
 
-Build DPDK:
-
-   .. code-block:: console
-
-      git clone git://dpdk.org/dpdk
-      cd dpdk
-      export RTE_SDK=$PWD
-      make install T=x86_64-native-linux-gcc DESTDIR=install
+See :doc:`../linux_gsg/build_dpdk` for details.
 
 
 Testpmd launch
@@ -340,13 +325,13 @@ Bind the virtio-net devices to DPDK:
 
    .. code-block:: console
 
-      $RTE_SDK/usertools/dpdk-devbind.py -b vfio-pci 0000:00:10.0 0000:00:11.0
+      ./dpdk/usertools/dpdk-devbind.py -b vfio-pci 0000:00:10.0 0000:00:11.0
 
 Start testpmd:
 
    .. code-block:: console
 
-      $RTE_SDK/install/bin/testpmd -l 0,1,2 --socket-mem 1024 -n 4 \
+      ./dpdk/<build_dir>/app/dpdk-testpmd -l 0,1,2 --socket-mem 1024 -n 4 \
           --proc-type auto --file-prefix pg -- \
           --portmask=3 --forward-mode=macswap --port-topology=chained \
           --disable-rss -i --rxq=1 --txq=1 \
diff --git a/doc/guides/howto/vfd.rst b/doc/guides/howto/vfd.rst
index 0ec0a0478d..5a62e6ff5a 100644
--- a/doc/guides/howto/vfd.rst
+++ b/doc/guides/howto/vfd.rst
@@ -83,7 +83,7 @@ The typical procedure to achieve this is as follows:
 
 #. Run a DPDK application on the PF in the host::
 
-      testpmd -l 0-7 -n 4 -- -i --txqflags=0
+      dpdk-testpmd -l 0-7 -n 4 -- -i --txqflags=0
 
 #. Bind the VF port to ``igb_uio`` in the VM::
 
@@ -91,7 +91,7 @@ The typical procedure to achieve this is as follows:
 
 #. Run a DPDK application on the VF in the VM::
 
-      testpmd -l 0-7 -n 4 -- -i --txqflags=0
+      dpdk-testpmd -l 0-7 -n 4 -- -i --txqflags=0
 
 
 Common functions of IXGBE and I40E
diff --git a/doc/guides/howto/virtio_user_for_container_networking.rst b/doc/guides/howto/virtio_user_for_container_networking.rst
index 412b29664b..5eab360a1c 100644
--- a/doc/guides/howto/virtio_user_for_container_networking.rst
+++ b/doc/guides/howto/virtio_user_for_container_networking.rst
@@ -64,7 +64,7 @@ some minor changes.
 	FROM ubuntu:latest
 	WORKDIR /usr/src/dpdk
 	COPY . /usr/src/dpdk
-	ENV PATH "$PATH:/usr/src/dpdk/x86_64-native-linux-gcc/app/"
+	ENV PATH "$PATH:/usr/src/dpdk/<build_dir>/app/"
 	EOT
 
 #. Build a Docker image.