diff --git a/doc/guides/rawdevs/dpaa2_cmdif.rst b/doc/guides/rawdevs/dpaa2_cmdif.rst
index be9805874b..7ac3963938 100644
--- a/doc/guides/rawdevs/dpaa2_cmdif.rst
+++ b/doc/guides/rawdevs/dpaa2_cmdif.rst
@@ -44,17 +44,6 @@ Currently supported by DPDK:
    Some part of fslmc bus code (mc flib - object library) routines are
    dual licensed (BSD & GPLv2).
 
-Pre-Installation Configuration
-------------------------------
-
-Config File Options
-~~~~~~~~~~~~~~~~~~~
-
-The following options can be modified in the ``config`` file.
-
-- ``CONFIG_RTE_LIBRTE_PMD_DPAA2_CMDIF_RAWDEV`` (default ``y``)
-
-  Toggle compilation of the ``lrte_pmd_dpaa2_cmdif`` driver.
 
 Enabling logs
 -------------
@@ -68,16 +57,6 @@ For enabling logs, use the following EAL parameter:
 Using ``pmd.raw.dpaa2.cmdif`` as log matching criteria, all Event PMD logs can be
 enabled which are lower than logging ``level``.
 
-Driver Compilation
-~~~~~~~~~~~~~~~~~~
-
-To compile the DPAA2 CMDIF PMD for Linux arm64 gcc target, run the
-following ``make`` command:
-
-.. code-block:: console
-
-   cd <DPDK-source-directory>
-   make config T=arm64-dpaa-linux-gcc install
 
 Initialization
 --------------
diff --git a/doc/guides/rawdevs/dpaa2_qdma.rst b/doc/guides/rawdevs/dpaa2_qdma.rst
index 129e83d5ef..92921fafdd 100644
--- a/doc/guides/rawdevs/dpaa2_qdma.rst
+++ b/doc/guides/rawdevs/dpaa2_qdma.rst
@@ -48,17 +48,6 @@ Currently supported by DPDK:
    Some part of fslmc bus code (mc flib - object library) routines are
    dual licensed (BSD & GPLv2).
 
-Pre-Installation Configuration
-------------------------------
-
-Config File Options
-~~~~~~~~~~~~~~~~~~~
-
-The following options can be modified in the ``config`` file.
-
-- ``CONFIG_RTE_LIBRTE_PMD_DPAA2_QDMA_RAWDEV`` (default ``y``)
-
-  Toggle compilation of the ``lrte_pmd_dpaa2_qdma`` driver.
 
 Enabling logs
 -------------
@@ -72,16 +61,6 @@ For enabling logs, use the following EAL parameter:
 Using ``pmd.raw.dpaa2.qdma`` as log matching criteria, all Event PMD logs can be
 enabled which are lower than logging ``level``.
 
-Driver Compilation
-~~~~~~~~~~~~~~~~~~
-
-To compile the DPAA2 QDMA PMD for Linux arm64 gcc target, run the
-following ``make`` command:
-
-.. code-block:: console
-
-   cd <DPDK-source-directory>
-   make config T=arm64-dpaa-linux-gcc install
 
 Initialization
 --------------
diff --git a/doc/guides/rawdevs/ifpga.rst b/doc/guides/rawdevs/ifpga.rst
index a3d92a62ea..dbd0d6e37d 100644
--- a/doc/guides/rawdevs/ifpga.rst
+++ b/doc/guides/rawdevs/ifpga.rst
@@ -76,16 +76,6 @@ summarized by the following block diagram::
      |        vdev_ifpga_cfg driver       |        |  Intel FpgaDev  |
      +------------------------------------+        +-----------------+
 
-Build options
--------------
-
-- ``CONFIG_RTE_LIBRTE_IFPGA_BUS`` (default ``y``)
-
-   Toggle compilation of IFPGA Bus library.
-
-- ``CONFIG_RTE_LIBRTE_IFPGA_RAWDEV`` (default ``y``)
-
-   Toggle compilation of the ``ifpga_rawdev`` driver.
 
 Run-time parameters
 -------------------
diff --git a/doc/guides/rawdevs/ntb.rst b/doc/guides/rawdevs/ntb.rst
index 39e4d65f87..2c5fa7690c 100644
--- a/doc/guides/rawdevs/ntb.rst
+++ b/doc/guides/rawdevs/ntb.rst
@@ -30,12 +30,6 @@ Skylake is https://www.intel.com/content/dam/support/us/en/documents/server-prod
 - Disable PCIe PII SSC (Spread Spectrum Clocking) for both hosts. This
   is a hardware requirement.
 
-Build Options
--------------
-
-- ``CONFIG_RTE_LIBRTE_PMD_NTB_RAWDEV`` (default ``y``)
-
-   Toggle compilation of the ``ntb`` driver.
 
 Device Setup
 ------------
diff --git a/doc/guides/rawdevs/octeontx2_dma.rst b/doc/guides/rawdevs/octeontx2_dma.rst
index 4a9794489e..6887da5278 100644
--- a/doc/guides/rawdevs/octeontx2_dma.rst
+++ b/doc/guides/rawdevs/octeontx2_dma.rst
@@ -26,18 +26,6 @@ Prerequisites and Compilation procedure
    See :doc:`../platform/octeontx2` for setup information.
 
 
-Pre-Installation Configuration
-------------------------------
-
-Config File Options
-~~~~~~~~~~~~~~~~~~~
-
-The following options can be modified in the ``config`` file.
-
-- ``CONFIG_RTE_LIBRTE_PMD_OCTEONTX2_DMA_RAWDEV`` (default ``y``)
-
-  Toggle compilation of the ``lrte_pmd_octeontx2_dma`` driver.
-
 Enabling logs
 -------------
 
diff --git a/doc/guides/rawdevs/octeontx2_ep.rst b/doc/guides/rawdevs/octeontx2_ep.rst
index b03fcf789a..fb9d346ccf 100644
--- a/doc/guides/rawdevs/octeontx2_ep.rst
+++ b/doc/guides/rawdevs/octeontx2_ep.rst
@@ -18,14 +18,6 @@ This OCTEON TX2 End Point mode PMD supports
 
 #. Packet Output - OCTEON TX2 to Host with info pointer mode.
 
-Config File Options
-~~~~~~~~~~~~~~~~~~~
-
-The following options can be modified in the ``config`` file.
-
-- ``CONFIG_RTE_LIBRTE_PMD_OCTEONTX2_EP_RAWDEV`` (default ``y``)
-
-  Toggle compilation of the ``lrte_pmd_octeontx2_ep`` driver.
 
 Initialization
 --------------