diff --git a/doc/guides/tools/comp_perf.rst b/doc/guides/tools/comp_perf.rst
index ee585d1024..269d7bdc9d 100644
--- a/doc/guides/tools/comp_perf.rst
+++ b/doc/guides/tools/comp_perf.rst
@@ -100,13 +100,7 @@ Application Options
 Compiling the Tool
 ------------------
 
-**Step 1: PMD setting**
-
-The ``dpdk-test-compress-perf`` tool depends on compression device drivers PMD which
-can be disabled by default in the build configuration file ``common_base``.
-The compression device drivers PMD which should be tested can be enabled by setting e.g.::
-
-   CONFIG_RTE_LIBRTE_PMD_ISAL=y
+See :doc:`../linux_gsg/build_dpdk` for compilation steps.
 
 
 Running the Tool
@@ -116,5 +110,5 @@ The tool has a number of command line options. Here is the sample command line:
 
 .. code-block:: console
 
-   ./build/app/dpdk-test-compress-perf  -l 4 -- --driver-name compress_qat --input-file test.txt --seg-sz 8192
+   ./<build_dir>/app/dpdk-test-compress-perf  -l 4 -- --driver-name compress_qat --input-file test.txt --seg-sz 8192
     --compress-level 1:1:9 --num-iter 10 --extended-input-sz 1048576  --max-num-sgl-segs 16 --huffman-enc fixed
diff --git a/doc/guides/tools/cryptoperf.rst b/doc/guides/tools/cryptoperf.rst
index 28b729dbda..8aa8272c71 100644
--- a/doc/guides/tools/cryptoperf.rst
+++ b/doc/guides/tools/cryptoperf.rst
@@ -33,19 +33,8 @@ the hardware accelerator fully loaded and so measure maximum throughput.
 Compiling the Application
 -------------------------
 
-**Step 1: PMD setting**
 
-The ``dpdk-test-crypto-perf`` tool depends on crypto device drivers PMD which
-are disabled by default in the build configuration file ``common_base``.
-The crypto device drivers PMD which should be tested can be enabled by setting::
-
-   CONFIG_RTE_LIBRTE_PMD_<name>=y
-
-Setting example for open ssl PMD::
-
-   CONFIG_RTE_LIBRTE_PMD_OPENSSL=y
-
-**Step 2: Linearization setting**
+**Step 1: Linearization setting**
 
 It is possible linearized input segmented packets just before crypto operation
 for devices which doesn't support scatter-gather, and allows to measure
@@ -56,13 +45,10 @@ To set on the linearization options add below definition to the
 
    #define CPERF_LINEARIZATION_ENABLE
 
-**Step 3: Build the application**
+**Step 2: Build the application**
 
-Execute the ``dpdk-setup.sh`` script to build the DPDK library together with the
-``dpdk-test-crypto-perf`` application.
+See :doc:`../linux_gsg/build_dpdk` for compilation steps.
 
-Initially, the user must select a DPDK target to choose the correct target type
-and compiler options to use when building the libraries.
 The user must have all libraries, modules, updates and compilers installed
 in the system prior to this,
 as described in the earlier chapters in this Getting Started Guide.
diff --git a/doc/guides/tools/pdump.rst b/doc/guides/tools/pdump.rst
index 8a499c6c5b..6f9bd77ab1 100644
--- a/doc/guides/tools/pdump.rst
+++ b/doc/guides/tools/pdump.rst
@@ -19,12 +19,9 @@ a DPDK secondary process and is capable of enabling packet capture on dpdk ports
         framework initialization code. Refer ``app/test-pmd/testpmd.c``
         code to see how this is done.
 
-      * The ``dpdk-pdump`` tool depends on libpcap based PMD which is disabled
-        by default in the build configuration files,
-        owing to an external dependency on the libpcap development files
-        which must be installed on the board.
-        Once the libpcap development files are installed, the libpcap based PMD
-        can be enabled by setting CONFIG_RTE_LIBRTE_PMD_PCAP=y and recompiling the DPDK.
+      * The ``dpdk-pdump`` tool depends on DPDK pcap PMD, so the system should
+        have libpcap development files installed and the pcap PMD not disabled
+        in the build.
 
       * The ``dpdk-pdump`` tool runs as a DPDK secondary process. It exits when
         the primary application exits.
@@ -37,7 +34,7 @@ The tool has a number of command line options:
 
 .. code-block:: console
 
-   ./build/app/dpdk-pdump --
+   ./<build_dir>/app/dpdk-pdump --
                           [--multi]
                           --pdump '(port=<port id> | device_id=<pci id or vdev name>),
                                    (queue=<queue_id>),
@@ -120,5 +117,5 @@ Example
 
 .. code-block:: console
 
-   $ sudo ./build/app/dpdk-pdump -l 3 -- --pdump 'port=0,queue=*,rx-dev=/tmp/rx.pcap'
-   $ sudo ./build/app/dpdk-pdump -l 3,4,5 -- --multi --pdump 'port=0,queue=*,rx-dev=/tmp/rx-1.pcap' --pdump 'port=1,queue=*,rx-dev=/tmp/rx-2.pcap'
+   $ sudo ./<build_dir>/app/dpdk-pdump -l 3 -- --pdump 'port=0,queue=*,rx-dev=/tmp/rx.pcap'
+   $ sudo ./<build_dir>/app/dpdk-pdump -l 3,4,5 -- --multi --pdump 'port=0,queue=*,rx-dev=/tmp/rx-1.pcap' --pdump 'port=1,queue=*,rx-dev=/tmp/rx-2.pcap'
diff --git a/doc/guides/tools/proc_info.rst b/doc/guides/tools/proc_info.rst
index 0390b9c589..9772d97ef0 100644
--- a/doc/guides/tools/proc_info.rst
+++ b/doc/guides/tools/proc_info.rst
@@ -17,7 +17,7 @@ The application has a number of command line options:
 
 .. code-block:: console
 
-   ./$(RTE_TARGET)/app/dpdk-procinfo -- -m | [-p PORTMASK] [--stats | --xstats |
+   ./<build_dir>/app/dpdk-procinfo -- -m | [-p PORTMASK] [--stats | --xstats |
    --stats-reset | --xstats-reset] [ --show-port | --show-tm | --show-crypto |
    --show-ring[=name] | --show-mempool[=name] | --iter-mempool=name ]
 
diff --git a/doc/guides/tools/testbbdev.rst b/doc/guides/tools/testbbdev.rst
index 9969231451..03f23277c0 100644
--- a/doc/guides/tools/testbbdev.rst
+++ b/doc/guides/tools/testbbdev.rst
@@ -13,25 +13,10 @@ parameters passed to a python running script.
 Compiling the Application
 -------------------------
 
-**Step 1: PMD setting**
+**Build the application**
 
-The ``dpdk-test-bbdev`` tool depends on crypto device drivers PMD which
-are disabled by default in the build configuration file ``common_base``.
-The bbdevice drivers PMD which should be tested can be enabled by setting
+See :doc:`../linux_gsg/build_dpdk` for compilation steps.
 
-   ``CONFIG_RTE_LIBRTE_PMD_<name>=y``
-
-Setting example for (*baseband_turbo_sw*) PMD
-
-   ``CONFIG_RTE_LIBRTE_PMD_BBDEV_TURBO_SW=y``
-
-**Step 2: Build the application**
-
-Execute the ``dpdk-setup.sh`` script to build the DPDK library together with the
-``dpdk-test-bbdev`` application.
-
-Initially, the user must select a DPDK target to choose the correct target type
-and compiler options to use when building the libraries.
 The user must have all libraries, modules, updates and compilers installed
 in the system prior to this, as described in the earlier chapters in this
 Getting Started Guide.
@@ -60,7 +45,7 @@ The following are the command-line options:
 
 ``-p TESTAPP_PATH, --testapp_path TESTAPP_PATH``
  Indicates the path to the bbdev test app. If not specified path is set based
- on *$RTE_SDK* environment variable concatenated with "*/build/app/testbbdev*".
+ on "../.." concatenated with "*/build/app/dpdk-test-bbdev*".
 
 ``-e EAL_PARAMS, --eal_params EAL_PARAMS``
  Specifies EAL arguments which are passed to the test app. For more details,
@@ -82,9 +67,8 @@ The following are the command-line options:
 
 ``-v TEST_VECTOR [TEST_VECTOR ...], --test_vector TEST_VECTOR [TEST_VECTOR ...]``
  Specifies paths to the test vector files. If not specified path is set based
- on *$RTE_SDK* environment variable concatenated with
- "*/app/test-bbdev/test_vectors/bbdev_null.data*" and indicates default
- data file.
+ on "../.." concatenated with "*/app/test-bbdev/test_vectors/bbdev_null.data*"
+ and indicates default data file.
 
  **Example usage:**
 
@@ -259,8 +243,8 @@ They are chosen to have a good coverage across sizes and processing
 parameters while still keeping their number limited as part of sanity
 regression.
 
-Shortened tree of isg_cid-wireless_dpdk_ae with dpdk compiled for
-x86_64-native-linux-icc target:
+Shortened tree of isg_cid-wireless_dpdk_ae with dpdk compiled and output
+to the build directory:
 
 ::
 
@@ -268,16 +252,16 @@ x86_64-native-linux-icc target:
      |-- test-bbdev
          |-- test_vectors
 
- |-- x86_64-native-linux-icc
+ |-- build
      |-- app
-         |-- testbbdev
+         |-- dpdk-test-bbdev
 
 All bbdev devices
 ~~~~~~~~~~~~~~~~~
 
 .. code-block:: console
 
-  ./test-bbdev.py -p ../../x86_64-native-linux-icc/app/testbbdev
+  ./test-bbdev.py -p ../../build/app/dpdk-test-bbdev
   -v turbo_dec_default.data
 
 It runs all available tests using the test vector filled based on
@@ -291,7 +275,7 @@ baseband turbo_sw device
 
 .. code-block:: console
 
-  ./test-bbdev.py -p ../../x86_64-native-linux-icc/app/testbbdev
+  ./test-bbdev.py -p ../../build/app/dpdk-test-bbdev
   -e="--vdev=baseband_turbo_sw" -t 120 -c validation
   -v ./test_vectors/* -n 64 -b 8 32
 
diff --git a/doc/guides/tools/testeventdev.rst b/doc/guides/tools/testeventdev.rst
index 2ed67a6340..1127036bb5 100644
--- a/doc/guides/tools/testeventdev.rst
+++ b/doc/guides/tools/testeventdev.rst
@@ -15,11 +15,8 @@ Compiling the Application
 
 **Build the application**
 
-Execute the ``dpdk-setup.sh`` script to build the DPDK library together with the
-``dpdk-test-eventdev`` application.
+See :doc:`../linux_gsg/build_dpdk` for compilation steps.
 
-Initially, the user must select a DPDK target to choose the correct target type
-and compiler options to use when building the libraries.
 The user must have all libraries, modules, updates and compilers installed
 in the system prior to this,
 as described in the earlier chapters in this Getting Started Guide.
@@ -251,7 +248,7 @@ Example command to run order queue test:
 
 .. code-block:: console
 
-   sudo build/app/dpdk-test-eventdev --vdev=event_sw0 -- \
+   sudo <build_dir>/app/dpdk-test-eventdev --vdev=event_sw0 -- \
                 --test=order_queue --plcores 1 --wlcores 2,3
 
 
@@ -314,7 +311,7 @@ Example command to run order ``all types queue`` test:
 
 .. code-block:: console
 
-   sudo build/app/dpdk-test-eventdev --vdev=event_octeontx -- \
+   sudo <build_dir>/app/dpdk-test-eventdev --vdev=event_octeontx -- \
                         --test=order_atq --plcores 1 --wlcores 2,3
 
 
@@ -414,7 +411,7 @@ Example command to run perf queue test:
 
 .. code-block:: console
 
-   sudo build/app/dpdk-test-eventdev -c 0xf -s 0x1 --vdev=event_sw0 -- \
+   sudo <build_dir>/app/dpdk-test-eventdev -c 0xf -s 0x1 --vdev=event_sw0 -- \
         --test=perf_queue --plcores=2 --wlcore=3 --stlist=p --nb_pkts=0
 
 Example command to run perf queue test with ethernet ports:
@@ -428,7 +425,7 @@ Example command to run perf queue test with event timer adapter:
 
 .. code-block:: console
 
-   sudo  build/app/dpdk-test-eventdev --vdev="event_octeontx" -- \
+   sudo  <build_dir>/app/dpdk-test-eventdev --vdev="event_octeontx" -- \
                 --wlcores 4 --plcores 12 --test perf_queue --stlist=a \
                 --prod_type_timerdev --fwd_latency
 
@@ -514,14 +511,14 @@ Example command to run perf ``all types queue`` test:
 
 .. code-block:: console
 
-   sudo build/app/dpdk-test-eventdev --vdev=event_octeontx -- \
+   sudo <build_dir>/app/dpdk-test-eventdev --vdev=event_octeontx -- \
                 --test=perf_atq --plcores=2 --wlcore=3 --stlist=p --nb_pkts=0
 
 Example command to run perf ``all types queue`` test with event timer adapter:
 
 .. code-block:: console
 
-   sudo  build/app/dpdk-test-eventdev --vdev="event_octeontx" -- \
+   sudo  <build_dir>/app/dpdk-test-eventdev --vdev="event_octeontx" -- \
                 --wlcores 4 --plcores 12 --test perf_atq --verbose 20 \
                 --stlist=a --prod_type_timerdev --fwd_latency
 
@@ -633,7 +630,7 @@ Example command to run pipeline queue test:
 
 .. code-block:: console
 
-    sudo build/app/dpdk-test-eventdev -c 0xf -s 0x8 --vdev=event_sw0 -- \
+    sudo <build_dir>/app/dpdk-test-eventdev -c 0xf -s 0x8 --vdev=event_sw0 -- \
         --test=pipeline_queue --wlcore=1 --prod_type_ethdev --stlist=a
 
 
@@ -725,5 +722,5 @@ Example command to run pipeline queue test:
 
 .. code-block:: console
 
-    sudo build/app/dpdk-test-eventdev -c 0xf -s 0x8 --vdev=event_sw0 -- \
+    sudo <build_dir>/app/dpdk-test-eventdev -c 0xf -s 0x8 --vdev=event_sw0 -- \
         --test=pipeline_atq --wlcore=1 --prod_type_ethdev --stlist=a